package knightminer.inspirations.library.recipe.cauldron.contents;

import net.minecraft.util.ResourceLocation;

import java.util.Optional;

/**
 * Base interface for all cauldron contents
 */
public interface ICauldronContents {

  /**
   * Gets this value as the given type
   * @param type  Type to get
   * @param <T>  Type of return
   * @return  Value, or empty optional if this does not have the given type
   */
  <T> Optional <T> get(CauldronContentType<T> type);

  /**
   * Gets the main type of these contents, used for serializing
   * @return  Main content type
   */
  CauldronContentType<?> getType();


  /* Display */

  /**
   * Gets the name of the texture for these contents. Should generally delegate to the type
   * @return  Texture location for this contents
   */
  ResourceLocation getTextureName();

  /**
   * Gets the color for this content type for tinting. Should generally delegate to the type
   * @return  Tint color
   */
  int getTintColor();
}
